package net.wanji.feign.service;

import net.wanji.feign.pojo.result.JsonViewObject;
import net.wanji.feign.pojo.vo.*;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * @author duanruiming
 * @date 2023/01/09 15:29
 */
@FeignClient(name = "UtcFeignClients", url = "${utc.service.url}")
public interface UtcFeignClients {

    @PostMapping("/signalStatus/runningStatusAlarm")
    JsonViewObject runningStatusAlarm();

    @PostMapping("/controlCommand/schemeSend")
    JsonViewObject schemeSend(@RequestBody SchemeSendVO schemeSendVO);

    @PostMapping("/controlCommand/planSend")
    JsonViewObject planSend(@RequestBody PlanSendVO planSendVO);

    @PostMapping("/controlCommand/scheduleSend")
    JsonViewObject scheduleSend(@RequestBody ScheduleSendVO scheduleSendVO);

    @PostMapping("/controlCommand/phaseTimingSend")
    JsonViewObject phaseTimingSend(@RequestBody PhaseTimingSendVO phaseTimingSendVO);

    @PostMapping("/controlCommand/allRedControl")
    JsonViewObject allRedControl(@RequestBody ControlCommandVO commandVO);

    @PostMapping("/controlCommand/yellowLightControl")
    JsonViewObject yellowLightControl(@RequestBody ControlCommandVO commandVO);

    @PostMapping("/controlCommand/closeLightControl")
    JsonViewObject closeLightControl(@RequestBody ControlCommandVO commandVO);

    @PostMapping("/controlCommand/stepControl")
    JsonViewObject stepControl(@RequestParam String code, @RequestParam Integer command, @RequestParam int stepNum);

    @PostMapping("/controlCommand/recoverSchedule")
    JsonViewObject recoverSchedule(@RequestParam String code);

    @PostMapping("/controlCommand/lockControl")
    JsonViewObject lockControl(@RequestBody LockControlVO lockControlVO);

    @PostMapping("/controlCommand/phaseDiffSend")
    JsonViewObject phaseDiffSend();

    /**
     * 方案数据-方案信息、相位信息、灯组信息
     */
    @PostMapping("/staticInfo/schemePhaseLights")
    JsonViewObject schemePhaseLights(@RequestBody CrossIdVO crossIdVO);

    @PostMapping("/manufacturer/list")
    JsonViewObject listManufacturerInfo(ManufacturerVO manufacturerPO);

    @PostMapping("/crossInfo/list")
    JsonViewObject listCrossInfo(CrossInfoVO crossInfoVO);
}
